package com.staffing.custom.mapper;

import java.util.List;
import com.staffing.custom.domain.StTransferRecord;

/**
 * 微信转账记录Mapper接口
 * 
 * @author staffing
 * @date 2024-09-06
 */
public interface StTransferRecordMapper 
{
    /**
     * 查询微信转账记录
     * 
     * @param id 微信转账记录主键
     * @return 微信转账记录
     */
    public StTransferRecord selectStTransferRecordById(Long id);

    /**
     * 查询微信转账记录列表
     * 
     * @param stTransferRecord 微信转账记录
     * @return 微信转账记录集合
     */
    public List<StTransferRecord> selectStTransferRecordList(StTransferRecord stTransferRecord);

    /**
     * 新增微信转账记录
     * 
     * @param stTransferRecord 微信转账记录
     * @return 结果
     */
    public int insertStTransferRecord(StTransferRecord stTransferRecord);

    /**
     * 修改微信转账记录
     * 
     * @param stTransferRecord 微信转账记录
     * @return 结果
     */
    public int updateStTransferRecord(StTransferRecord stTransferRecord);

    /**
     * 删除微信转账记录
     * 
     * @param id 微信转账记录主键
     * @return 结果
     */
    public int deleteStTransferRecordById(Long id);

    /**
     * 批量删除微信转账记录
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteStTransferRecordByIds(Long[] ids);
}
